'use strict';

var browserify = require('browserify');
var gulp = require('gulp');
var source = require('vinyl-source-stream');
var buffer = require('vinyl-buffer');
var uglify = require('gulp-uglify');
var sourcemaps = require('gulp-sourcemaps');
var gutil = require('gulp-util');
var jshint = require('gulp-jshint');

gulp.task('lint', function () {

  return gulp.src(['src/*.js', 'src/**/*.js'])
    .pipe(jshint())
    .pipe(jshint.reporter('default'));
});

gulp.task('js', ['lint'], function() {
  var b = browserify({
    entries: './src/TableSort.js',
    debug: true
  });

  return b.bundle()
    .pipe(source('TableSort.js'))
    .pipe(buffer())
    .pipe(sourcemaps.init({loadMaps: true}))
    .pipe(sourcemaps.write('./'))
    .pipe(gulp.dest('./dist'));
});

gulp.task('js-min', ['lint'], function () {
  var b = browserify({
    entries: './src/TableSort.js',
    debug: true
  });

  return b.bundle()
    .pipe(source('TableSort.min.js'))
    .pipe(buffer())
    .pipe(sourcemaps.init({loadMaps: true}))
      .pipe(uglify())
      .on('error', gutil.log)
    .pipe(sourcemaps.write('./'))
    .pipe(gulp.dest('./dist'));
});

gulp.task('watch', function () {
  gulp.watch(['src/**/*.js'], ['js', 'js-min']);
});

gulp.task ('default', ['js', 'js-min', 'watch']);
